% Bandwidth calculation of the signal radiated by the Radar %
% theoretical study

clc; clear all;
format long;            % prints out more digits
format compact;         % makes the output more compact

% Variables  %
c = 299792458;
Nm = 5000;  %500;  %256; %512;      % modulation factor
f0 = 1.575e9;
omg0 = 2*pi*f0;
delO = (5/100)*omg0;
T0 = 1./f0;
Tp = Nm*T0;
PercntBW = 50;
omg_u = omg0 + 0.0000541*omg0;
omg_l = omg0 - 0.0000541*omg0;
S = 'pulse';   %'chirp';  %  --> type of signal

%============================================================================
% Integration to get the TOTAL POWER in the spectrum of the signal
%============================================================================
if (strcmp('pulse',S) == 1)
%------------- REGULAR PULSE -----------------------------% 
  %E_sca = (1/pi).*real(GQuad_Intv(@(omg)InptSignl_Energy(omg,S,Tp,delO),0,2*omg0,1e4,6));
  E_sca1 = (1/pi).*real(quadgk(@(omg)InptSignl_Energy(omg,S,Tp,delO),0,0.95*omg0,'MaxIntervalCount',1e20));
  E_sca2 = (1/pi).*real(quadgk(@(omg)InptSignl_Energy(omg,S,Tp,delO),0.95*omg0,1.05*omg0,'MaxIntervalCount',1e20));
  E_sca3 = (1/pi).*real(quadgk(@(omg)InptSignl_Energy(omg,S,Tp,delO),1.05*omg0,50*omg0,'MaxIntervalCount',1e20));
  %E_sca4 = (1/pi).*real(quadgk(@(omg)InptSignl_Energy(omg,S,Tp,delO),30*omg0,50*omg0,'MaxIntervalCount',1e20));
  E_sca = E_sca1 + E_sca2 + E_sca3;
  %E_sca = (1/pi).*real(quadgk(@(omg)InptSignl_Energy(omg,S,Tp,delO),0,5*omg0, .....
  %                        'MaxIntervalCount',1e20));
  %                        'MaxIntervalCount',1e20,'RelTol',1e-20,'AbsTol',1e-20));                        
else
%-------------- CHIRP ------------------------------------%
   lim1 = 0;
   lim2 = omg0 - delO;
   lim3 = omg0 + delO;
   lim4 = 1.8*omg0;
   lim5 = 5*omg0;   
   E_sca1 = (1/pi).*real(GQuad_Intv(@(omg)InptSignl_Energy(omg,S,Tp,delO),lim1,lim2,1e3,6));
   E_sca2 = (1/pi).*real(GQuad_Intv(@(omg)InptSignl_Energy(omg,S,Tp,delO),lim2,lim3,1e4,6));
   E_sca3 = (1/pi).*real(GQuad_Intv(@(omg)InptSignl_Energy(omg,S,Tp,delO),lim3,lim4,1e4,6));
   E_sca4 = (1/pi).*real(GQuad_Intv(@(omg)InptSignl_Energy(omg,S,Tp,delO),lim4,lim5,1e3,6));
   %E_sca1 = (1/pi).*real(quadgk(@(omg)InptSignl_Energy(omg,S,Tp,delO),0,0.9*omg0,'MaxIntervalCount',1e20));
   %E_sca2 = (1/pi).*real(quadgk(@(omg)InptSignl_Energy(omg,S,Tp,delO),0.9*omg0,1.05*omg0,'MaxIntervalCount',1e20));
   %E_sca3 = (1/pi).*real(quadgk(@(omg)InptSignl_Energy(omg,S,Tp,delO),1.05*omg0,1.2*omg0,'MaxIntervalCount',1e20));
   %E_sca4 = (1/pi).*real(quadgk(@(omg)InptSignl_Energy(omg,S,Tp,delO),1.2*omg0,5*omg0,'MaxIntervalCount',1e20));  
   %E_sca4 = (1/pi).*real(quadgk(@(omg)InptSignl_Energy(omg,S,Tp,delO),30*omg0,50*omg0,'MaxIntervalCount',1e20));
   %E_sca1 = (1/2/pi).*(quadgk(@(omg)InptSignl_Energy(omg,S,Tp,delO),0,0.95*omg0,'MaxIntervalCount',1e20));
   %E_sca2 = (1/2/pi).*(quadgk(@(omg)InptSignl_Energy(omg,S,Tp,delO),0.95*omg0,1.05*omg0,'MaxIntervalCount',1e20));
   %E_sca3 = (1/2/pi).*(quadgk(@(omg)InptSignl_Energy(omg,S,Tp,delO),1.05*omg0,5*omg0,'MaxIntervalCount',1e20));
   %E_sca4 = (1/2/pi).*(quadgk(@(omg)InptSignl_Energy(omg,S,Tp,delO),-0.95*omg0,0,'MaxIntervalCount',1e20));
   %E_sca5 = (1/2/pi).*(quadgk(@(omg)InptSignl_Energy(omg,S,Tp,delO),-1.05*omg0,-0.95*omg0,'MaxIntervalCount',1e20));
   %E_sca6 = (1/2/pi).*(quadgk(@(omg)InptSignl_Energy(omg,S,Tp,delO),-5*omg0,-1.05*omg0,'MaxIntervalCount',1e20));  
   E_sca = E_sca1 + E_sca2 + E_sca3 + E_sca4;  
end
E_sca_tot = E_sca;

%============================================================================
% Integration to get the POWER WITHIN THE BAND in the spectrum of the signal
%============================================================================
if (strcmp('pulse',S) == 1)
%------------- REGULAR PULSE -----------------------------% 
  lim1 = 0;
  lim2 = 0.95*omg0;
  lim3 = 1.05*omg0;
  lim4 = 50*omg0;
  if (omg_l < lim2)
      lim1 = omg_l;
  else
   if (lim2 < omg_l < lim3)   
       lim1 = omg_l;
       lim2 = omg_l;
   else
    if (lim3 < omg_l < lim4)
        lim1 = omg_l;
        lim2 = omg_l;
        lim3 = omg_l;
    end
   end
  end 
  if (omg_u > lim3)
      lim4 = omg_u;
  else
   if (lim3 > omg_u > lim2)   
       lim4 = omg_u;
       lim3 = omg_u;
   else
    if (lim2 < omg_u < lim1)
        lim4 = omg_u;
        lim3 = omg_u;
        lim2 = omg_u;
    end
   end
  end     
   
  %E_sca = (1/pi).*real(GQuad_Intv(@(omg)InptSignl_Energy(omg,S,Tp,delO),omg_l,omg_u,1e4,6));
  E_sca1 = (1/pi).*real(quadgk(@(omg)InptSignl_Energy(omg,S,Tp,delO),lim1,lim2,'MaxIntervalCount',1e20));
  E_sca2 = (1/pi).*real(quadgk(@(omg)InptSignl_Energy(omg,S,Tp,delO),lim2,lim3,'MaxIntervalCount',1e20));
  E_sca3 = (1/pi).*real(quadgk(@(omg)InptSignl_Energy(omg,S,Tp,delO),lim3,lim4,'MaxIntervalCount',1e20));
  %E_sca4 = (1/pi).*real(quadgk(@(omg)InptSignl_Energy(omg,S,Tp,delO),30*omg0,50*omg0,'MaxIntervalCount',1e20));
  E_sca = E_sca1 + E_sca2 + E_sca3;
  %E_sca = (1/pi).*real(quadgk(@(omg)InptSignl_Energy(omg,S,Tp,delO),0,5*omg0, .....
  %                        'MaxIntervalCount',1e20));
  %                        'MaxIntervalCount',1e20,'RelTol',1e-20,'AbsTol',1e-20));                        
else
%-------------- CHIRP ------------------------------------%
   lim1 = 0;
   lim2 = omg0 - delO;
   lim3 = omg0 + delO;
   lim4 = 1.8*omg0;
   lim5 = 5*omg0;
   if (omg_l < lim2)
       lim1 = omg_l;
   else
    if (lim2 < omg_l < lim3)   
        lim1 = omg_l;
        lim2 = omg_l;
    else
     if (lim3 < omg_l < lim4)
         lim1 = omg_l;
         lim2 = omg_l;
         lim3 = omg_l;
     else
      if (lim4 < omg_l < lim5)
          lim1 = omg_l;
          lim2 = omg_l;
          lim3 = omg_l;
          lim4 = omg_l;
      end
     end
    end
   end 
   if (omg_u > lim4)
       lim5 = omg_u;
   else
    if (lim4 > omg_u > lim3)   
        lim5 = omg_u;
        lim4 = omg_u;
    else
     if (lim3 < omg_u < lim2)
         lim5 = omg_u;
         lim4 = omg_u;
         lim3 = omg_u;
     else
      if (lim2 < omg_u < lim1)
          lim5 = omg_u;
          lim4 = omg_u;
          lim3 = omg_u;
          lim2 = omg_u;
      end
     end
    end
   end     
 
   E_sca1 = (1/pi).*real(GQuad_Intv(@(omg)InptSignl_Energy(omg,S,Tp,delO),lim1,lim2,1e3,6));
   E_sca2 = (1/pi).*real(GQuad_Intv(@(omg)InptSignl_Energy(omg,S,Tp,delO),lim2,lim3,1e4,6));
   E_sca3 = (1/pi).*real(GQuad_Intv(@(omg)InptSignl_Energy(omg,S,Tp,delO),lim3,lim4,1e4,6));
   E_sca4 = (1/pi).*real(GQuad_Intv(@(omg)InptSignl_Energy(omg,S,Tp,delO),lim4,lim5,1e3,6));
   %E_sca1 = (1/pi).*real(quadgk(@(omg)InptSignl_Energy(omg,S,Tp,delO),0,0.9*omg0,'MaxIntervalCount',1e20));
   %E_sca2 = (1/pi).*real(quadgk(@(omg)InptSignl_Energy(omg,S,Tp,delO),0.9*omg0,1.05*omg0,'MaxIntervalCount',1e20));
   %E_sca3 = (1/pi).*real(quadgk(@(omg)InptSignl_Energy(omg,S,Tp,delO),1.05*omg0,1.2*omg0,'MaxIntervalCount',1e20));
   %E_sca4 = (1/pi).*real(quadgk(@(omg)InptSignl_Energy(omg,S,Tp,delO),1.2*omg0,5*omg0,'MaxIntervalCount',1e20));  
   %E_sca4 = (1/pi).*real(quadgk(@(omg)InptSignl_Energy(omg,S,Tp,delO),30*omg0,50*omg0,'MaxIntervalCount',1e20));
   %E_sca1 = (1/2/pi).*(quadgk(@(omg)InptSignl_Energy(omg,S,Tp,delO),0,0.95*omg0,'MaxIntervalCount',1e20));
   %E_sca2 = (1/2/pi).*(quadgk(@(omg)InptSignl_Energy(omg,S,Tp,delO),0.95*omg0,1.05*omg0,'MaxIntervalCount',1e20));
   %E_sca3 = (1/2/pi).*(quadgk(@(omg)InptSignl_Energy(omg,S,Tp,delO),1.05*omg0,5*omg0,'MaxIntervalCount',1e20));
   %E_sca4 = (1/2/pi).*(quadgk(@(omg)InptSignl_Energy(omg,S,Tp,delO),-0.95*omg0,0,'MaxIntervalCount',1e20));
   %E_sca5 = (1/2/pi).*(quadgk(@(omg)InptSignl_Energy(omg,S,Tp,delO),-1.05*omg0,-0.95*omg0,'MaxIntervalCount',1e20));
   %E_sca6 = (1/2/pi).*(quadgk(@(omg)InptSignl_Energy(omg,S,Tp,delO),-5*omg0,-1.05*omg0,'MaxIntervalCount',1e20));  
   E_sca = E_sca1 + E_sca2 + E_sca3 + E_sca4;  
end
E_sca_bw = E_sca;

Energy_ratio = E_sca_bw./E_sca_tot;
disp(Energy_ratio)



