% f --> function handle for the integrand
% a, b --> lower and upper limits
% n --> number of intervals
% k --> number of points of Gaussian Quadrature
function I = GQuad_Intv(f,a,b,n,k)
h = (b-a)/n;
S = 0;
for q = 1:n
    l = a + (q-1)*h;
    u = a + q*h;
    int = Gauss_quad(f,l,u,k);
    S = S + int;
end
I = S;