% f --> function handle for the integrand
% a, b --> lower and upper limits
% n --> number of intervals
% k --> number of points of Gaussian Quadrature
function [I1, I2, I3] = GQuad_Intv1(f,a,b,n,k)
h = (b-a)/n;
S1 = 0;
S2 = 0;
S3 = 0;
for q = 1:n
    l = a + (q-1)*h;
    u = a + q*h;
    [int1, int2, int3] = Gauss_quad1(f,l,u,k);
    S1 = S1 + int1;
    S2 = S2 + int2;
    S3 = S3 + int3;
end
I1 = S1;
I2 = S2;
I3 = S3;