function E2_scaF = InptSignl_Energy(omg,S,Tp,delO)

% Variables  %
c = 299792458;
f0 = 1.575e9;
omg0 = 2*pi*f0;
lambda0 = c/f0;
omg1 = omg0 - delO;
%omg1 = omg0 - delO/2;


% Signal 1 --> Pulse  %
if (strcmp('pulse',S) == 1)  
    E_incF = (Tp/2).*(sinc(0.5.*(omg0-omg).*Tp) + sinc(0.5.*(omg0+omg).*Tp));
    %E_incF = 0.5.*(sinc(0.5.*(omg0-omg).*Tp./pi) + sinc(0.5.*(omg0+omg).*Tp./pi));
else
    %------------ For pulse centered at t = 0 -------------------------
    u1 = (-Tp/2 + (omg0-omg).*Tp./(2*delO)).*sqrt(delO/Tp);
    u2 = (Tp/2 + (omg0-omg).*Tp./(2*delO)).*sqrt(delO/Tp);
    u3 = (-Tp/2 + (omg0+omg).*Tp./(2*delO)).*sqrt(delO/Tp);
    u4 = (Tp/2 + (omg0+omg).*Tp./(2*delO)).*sqrt(delO/Tp);
    u5 = ((omg0-omg).^2).*Tp./(4*delO);
    u6 = ((omg0+omg).^2).*Tp./(4*delO);
    
    %------------ For pulse starting at t = 0 -------------------------
%     u1 = (0 + (omg1-omg).*Tp./(2*delO)).*sqrt(delO/Tp);
%     u2 = (Tp + (omg1-omg).*Tp./(2*delO)).*sqrt(delO/Tp);
%     u3 = (0 + (omg1+omg).*Tp./(2*delO)).*sqrt(delO/Tp);
%     u4 = (Tp + (omg1+omg).*Tp./(2*delO)).*sqrt(delO/Tp);
%     u5 = ((omg1-omg).^2).*Tp./(4*delO);
%     u6 = ((omg1+omg).^2).*Tp./(4*delO);    
    
    %--------------------------------------------------------------------
    F1u3 = sqrt(pi/2).*(myfresnelC(u3*sqrt(2/pi)) - 1i.*myfresnelS(u3*sqrt(2/pi)));
    F1u4 = sqrt(pi/2).*(myfresnelC(u4*sqrt(2/pi)) - 1i.*myfresnelS(u4*sqrt(2/pi)));
    F2u1 = sqrt(pi/2).*(myfresnelC(u1*sqrt(2/pi)) + 1i.*myfresnelS(u1*sqrt(2/pi)));
    F2u2 = sqrt(pi/2).*(myfresnelC(u2*sqrt(2/pi)) + 1i.*myfresnelS(u2*sqrt(2/pi)));
    E_incF = (0.5*sqrt(Tp/delO)).*(exp(-1i.*u5).*(F2u2-F2u1) + exp(1i.*u6).*(F1u4-F1u3));
end
  
E2_scaF = (abs(E_incF)).^2;