function E_scaF = ScatrSignl(omg,t,S,Tp,delO)

% Variables  %
c = 299792458;
f0 = 1.575e9;
omg0 = 2*pi*f0;
lambda0 = c/f0;
omg1 = omg0 - delO;
%omg1 = omg0 - delO/2;
fr = omg./omg0;

% Patch parameters
R = 50;
Zout = 10;   % 0;  %0.5;
Q = 5;  %58.24;  %10;  %
Xp0 = 10.8;
%Xp0 = 0;
Ereff = 1.5;   % effective eps_r of the delay transmission line %
L = 0.0;
effL = 1.0*lambda0;
Lp = Xp0/omg0;


% Signal 1 --> Pulse  %
if (strcmp('pulse',S) == 1)  
    E_incF = (Tp/2).*(sinc(0.5.*(omg0-omg).*Tp) + sinc(0.5.*(omg0+omg).*Tp));
else
    %------------ For pulse centered at t = 0 -------------------------
    u1 = (-Tp/2 + (omg0-omg).*Tp./(2*delO)).*sqrt(delO/Tp);
    u2 = (Tp/2 + (omg0-omg).*Tp./(2*delO)).*sqrt(delO/Tp);
    u3 = (-Tp/2 + (omg0+omg).*Tp./(2*delO)).*sqrt(delO/Tp);
    u4 = (Tp/2 + (omg0+omg).*Tp./(2*delO)).*sqrt(delO/Tp);
    u5 = ((omg0-omg).^2).*Tp./(4*delO);
    u6 = ((omg0+omg).^2).*Tp./(4*delO);
    
    %------------ For pulse starting at t = 0 -------------------------
%     u1 = (0 + (omg1-omg).*Tp./(2*delO)).*sqrt(delO/Tp);
%     u2 = (Tp + (omg1-omg).*Tp./(2*delO)).*sqrt(delO/Tp);
%     u3 = (0 + (omg1+omg).*Tp./(2*delO)).*sqrt(delO/Tp);
%     u4 = (Tp + (omg1+omg).*Tp./(2*delO)).*sqrt(delO/Tp);
%     u5 = ((omg1-omg).^2).*Tp./(4*delO);
%     u6 = ((omg1+omg).^2).*Tp./(4*delO);    
    
    %--------------------------------------------------------------------
    F1u3 = sqrt(pi/2).*(myfresnelC(u3*sqrt(2/pi)) - 1i.*myfresnelS(u3*sqrt(2/pi)));
    F1u4 = sqrt(pi/2).*(myfresnelC(u4*sqrt(2/pi)) - 1i.*myfresnelS(u4*sqrt(2/pi)));
    F2u1 = sqrt(pi/2).*(myfresnelC(u1*sqrt(2/pi)) + 1i.*myfresnelS(u1*sqrt(2/pi)));
    F2u2 = sqrt(pi/2).*(myfresnelC(u2*sqrt(2/pi)) + 1i.*myfresnelS(u2*sqrt(2/pi)));
    E_incF = (0.5*sqrt(Tp/delO)).*(exp(-1i.*u5).*(F2u2-F2u1) + exp(1i.*u6).*(F1u4-F1u3));
end
  
% Scattered Field %
%Tdn = L.*sqrt(Ereff)./c;
Tdn = effL./c;
delay = exp(-1i.*(omg-omg0).*Tdn);
%-------------------------------------------------------------------
%-------------- WITHOUT TUNING CAPACITOR ---------------------------
Zin = R./(1 + 1i.*2.*Q.*((omg./omg0) - 1)) + 1i.*omg.*Lp;
Zin0 = R + 1i.*Xp0;
Term1 = (omg./omg0);
Term2 = ((1 - 1i.*omg.*Lp./Zin)./(1 - 1i.*Xp0./Zin0));
Term3 = (Zin./(Zout + Zin))./(Zin0./(Zout + Zin0));
%---------------- WITH TUNING CAPACITOR ----------------------------
% Zin = R./(1 + 1i.*2.*Q.*((omg./omg0) - 1)) + 1i.*Xp0.*(fr - 1./fr);
% Zin0 = R;
% if (fr == 0)  % when omg = 0
%     Term1 = 0;
%     Term2 = 1./(1 - 1i.*Xp0./Zin0);   %% ?? check again -> think its correct
%     Term3 = 1./(Zin0./(Zout + Zin0));
% else
%     Term1 = (omg./omg0);
%     Term2 = ((1 - 1i.*omg.*Lp./Zin)./(1 - 1i.*Xp0./Zin0));
%     Term3 = (Zin./(Zout + Zin))./(Zin0./(Zout + Zin0));
% end
%-------------------------------------------------------------------
Refln = Term1.*Term2.*Term3;
%------------ when INTEGRATOR is included --------------------------
%Term2 = 1./(1 - 1i.*Xp0./Zin0);
%Refln = Term2.*Term3;
%-------------------------------------------------------------------
Scatr = (1 - Refln.*delay);
%Scatr = 1;
%Scatr = Refln;
%E_incF = 1;
E_scaF = E_incF.*Scatr.*exp(1i.*omg.*t);
