% Radar signal at the receiver after scattering cancellation %
% theoretical study

clc; clear all;
format long;            % prints out more digits
format compact;         % makes the output more compact

% Variables  %
c = 299792458;
%N = 1024*1024;  % number of points of FFT
Nm = 500;  %256; %512;      % modulation factor
f0 = 1.575e9;
omg0 = 2*pi*f0;
delO = (2/100)*omg0;
T0 = 1./f0;
Tp = Nm*T0;    % CHANGE BACK !!!!!!
%Tp = 1e-7;
%Ts = (2*Tp)/(N-1);
%fs = 1/Ts;
Nplot = 500;  %2000;  %500
omg1 = omg0 - delO;
%omg1 = omg0 - delO/2;

% ---------- Using continious Fourier transform ---------------- %
%t = (0:(Nplot-1)).*(2*Tp/Nplot);
t = (-Nplot/2:(Nplot/2-1)).*(2*Tp/Nplot);
S = 'chirp';  %'pulse';   %  --> type of signal

if (strcmp('pulse',S) == 1)
% Signal 1 --> Pulse  %    
    %t = (0:(Nplot-1)).*(2*Tp/Nplot);
    Puls = horzcat(zeros(1,Nplot/4),ones(1,Nplot/2),zeros(1,Nplot/4));    % Pulse: Tp = 50%
    E_inc = Puls.*cos(omg0.*t);
else
% Signal 2 --> Chirp  %    
    t = (-Nplot/2:(Nplot/2-1)).*(2*Tp/Nplot);
    Puls = horzcat(zeros(1,Nplot/4),ones(1,Nplot/2),zeros(1,Nplot/4));    % Pulse: Tp = 50%
    E_inc = Puls.*cos((omg0 + delO.*t./Tp).*t);
    %Puls = horzcat(ones(1,Nplot/2),zeros(1,Nplot/2));    % Pulse: Tp = 50%    
    %E_inc = Puls.*cos((omg1 + delO.*t./Tp).*t);
end    

% %------------------ SCATTERED FIELD ---------------------%
E_sca = zeros(1,Nplot);
for i = 1:length(t)
  %------------- REGULAR PULSE -----------------------------% 
%   %E_sca(i) = (1/pi).*real(GQuad_Intv(@(omg)ScatrSignl(omg,t(i),S,Tp,delO),0,2*omg0,1e4,6));
%   E_sca1 = (1/pi).*real(quadgk(@(omg)ScatrSignl(omg,t(i),S,Tp,delO),0,0.95*omg0,'MaxIntervalCount',1e20));
%   E_sca2 = (1/pi).*real(quadgk(@(omg)ScatrSignl(omg,t(i),S,Tp,delO),0.95*omg0,1.05*omg0,'MaxIntervalCount',1e20));
%   E_sca3 = (1/pi).*real(quadgk(@(omg)ScatrSignl(omg,t(i),S,Tp,delO),1.05*omg0,10*omg0,'MaxIntervalCount',1e20));
%   %E_sca4 = (1/pi).*real(quadgk(@(omg)ScatrSignl(omg,t(i),S,Tp,delO),30*omg0,50*omg0,'MaxIntervalCount',1e20));
%   E_sca(i) = E_sca1 + E_sca2 + E_sca3;
%   %E_sca(i) = (1/pi).*real(quadgk(@(omg)ScatrSignl(omg,t(i),S,Tp,delO),0,5*omg0, .....
%   %                        'MaxIntervalCount',1e20));
%   %                        'MaxIntervalCount',1e20,'RelTol',1e-20,'AbsTol',1e-20));                        
  %-------------- CHIRP ------------------------------------%
  %E_sca1 = (1/pi).*real(GQuad_Intv(@(omg)ScatrSignl(omg,t(i),S,Tp,delO),0,0.9*omg0,1e3,6));
  %E_sca2 = (1/pi).*real(GQuad_Intv(@(omg)ScatrSignl(omg,t(i),S,Tp,delO),0.9*omg0,1.05*omg0,1e4,6));
  %E_sca3 = (1/pi).*real(GQuad_Intv(@(omg)ScatrSignl(omg,t(i),S,Tp,delO),1.05*omg0,1.2*omg0,1e4,6));
  %E_sca4 = (1/pi).*real(GQuad_Intv(@(omg)ScatrSignl(omg,t(i),S,Tp,delO),1.2*omg0,5*omg0,1e3,6));
  E_sca1 = (1/pi).*real(quadgk(@(omg)ScatrSignl(omg,t(i),S,Tp,delO),0,0.9*omg0,'MaxIntervalCount',1e20));
  E_sca2 = (1/pi).*real(quadgk(@(omg)ScatrSignl(omg,t(i),S,Tp,delO),0.9*omg0,1.05*omg0,'MaxIntervalCount',1e20));
  E_sca3 = (1/pi).*real(quadgk(@(omg)ScatrSignl(omg,t(i),S,Tp,delO),1.05*omg0,1.2*omg0,'MaxIntervalCount',1e20));
  E_sca4 = (1/pi).*real(quadgk(@(omg)ScatrSignl(omg,t(i),S,Tp,delO),1.2*omg0,30*omg0,'MaxIntervalCount',1e20));  
  %E_sca4 = (1/pi).*real(quadgk(@(omg)ScatrSignl(omg,t(i),S,Tp,delO),30*omg0,50*omg0,'MaxIntervalCount',1e20));
  %E_sca1 = (1/2/pi).*(quadgk(@(omg)ScatrSignl(omg,t(i),S,Tp,delO),0,0.95*omg0,'MaxIntervalCount',1e20));
  %E_sca2 = (1/2/pi).*(quadgk(@(omg)ScatrSignl(omg,t(i),S,Tp,delO),0.95*omg0,1.05*omg0,'MaxIntervalCount',1e20));
  %E_sca3 = (1/2/pi).*(quadgk(@(omg)ScatrSignl(omg,t(i),S,Tp,delO),1.05*omg0,5*omg0,'MaxIntervalCount',1e20));
  %E_sca4 = (1/2/pi).*(quadgk(@(omg)ScatrSignl(omg,t(i),S,Tp,delO),-0.95*omg0,0,'MaxIntervalCount',1e20));
  %E_sca5 = (1/2/pi).*(quadgk(@(omg)ScatrSignl(omg,t(i),S,Tp,delO),-1.05*omg0,-0.95*omg0,'MaxIntervalCount',1e20));
  %E_sca6 = (1/2/pi).*(quadgk(@(omg)ScatrSignl(omg,t(i),S,Tp,delO),-5*omg0,-1.05*omg0,'MaxIntervalCount',1e20));  
  E_sca(i) = E_sca1 + E_sca2 + E_sca3 + E_sca4;  
end


figure(1)
plot(t,E_inc)
title('incident signal, carrier frequency \itf\rm_0 = 1.575 GHz')
xlim([t(1) t(Nplot)])
xlabel('time (in seconds)')
ylabel('incident E field (in V/m)')
figure(2)
plot(t,E_sca.*0.2)
title('scattered signal, carrier frequency \itf\rm_0 = 1.575 GHz')
xlim([t(1) t(Nplot)])
xlabel('time (in seconds)')
ylabel('normalized scattered E field (in V/m)')

% omg1=0:0.002*omg0:2*omg0;
% for Zout = 8:12
%     colr = ['m' 'c' 'r' 'g' 'b' 'k' 'm' 'c' 'r' 'g' 'b' 'k' 'm' 'c' 'r' 'g' 'b' 'k' 'm' 'c' 'r' 'g' 'b' 'k'];
%     E_plot = ScatrSignl(omg1,0,S,Tp,delO,Zout);
%     plot(omg1,abs(E_plot),colr(Zout))
%     hold on
% end
% hold off
