clc; clear all;

xx = -160:4:160;
yy = 0:2:250;
Nx = length(xx);
Ny = length(yy);

Ex_m_1 = load('Ex_mag_0.mat');
Ex_m_2 = load('Ex_mag_2.mat');
Ex_m_3 = load('Ex_mag_3.mat');
Ex_p_1 = load('Ex_phs_0.mat');
Ex_p_2 = load('Ex_phs_2.mat');
Ex_p_3 = load('Ex_phs_3.mat');
Ex_mag_1 = Ex_m_1.Ex_mag;
Ex_mag_2 = Ex_m_2.Ex_mag;
Ex_mag_3 = Ex_m_2.Ex_mag;
Ex_phs_1 = Ex_p_1.Ex_phs;
Ex_phs_2 = Ex_p_2.Ex_phs;
Ex_phs_3 = Ex_p_3.Ex_phs;

Ex_1 = Ex_mag_1.*exp(1i.*Ex_phs_1);   % only interrogator (source)
Ex_2 = Ex_mag_2.*exp(1i.*Ex_phs_2);   % defender off - only scattering
Ex_3 = Ex_mag_3.*exp(1i.*Ex_phs_3);   % only defender on

Ex_4 = Ex_2 - Ex_1;
E_n = abs(Ex_4(Ny/2,(Nx+1)/2));
Ex_5 = Ex_4 - (Ex_4(Ny/2,(Nx+1)/2)/Ex_3(Ny/2,(Nx+1)/2)).*Ex_3;
Ex_mag = abs(Ex_5);
Ex_mag1 = abs(Ex_4);

figure(1)
contourf(yy,xx,Ex_mag'./E_n,10)
colorbar
xlabel('\itx\rm in mm')
ylabel('\ity\rm in mm')         
title('\itz\rm = 4 ft')         

figure(2)
%plot(yy,20.*log10((Ex_mag(:,(Nx+1)/2))'./E_n),'LineWidth',2)  
plot(yy,(Ex_mag(:,(Nx+1)/2))'./E_n,'LineWidth',2)  
xlabel('\itx\rm in mm')
%ylabel('Normalized \itE_x\rm in dB')
ylabel('Normalized |\itE_x\rm|')
title('\itz\rm = 4 ft, \itx\rm = 0')      % z is the x axis

figure(3)
%plot(xx,20.*log10((Ex_mag(Ny/2,:))./E_n),'LineWidth',2) 
plot(xx,(Ex_mag(Ny/2,:))./E_n,'LineWidth',2) 
xlabel('\ity\rm in mm')         % actually z axis in this case
%ylabel('Normalized \itE_x\rm in dB')
ylabel('Normalized |\itE_x\rm|')
title('\itz\rm = 4 ft, \ity\rm = 0')      % z is the x axis

figure(4)
contourf(yy,xx,Ex_mag1'./E_n,10)
colorbar
xlabel('\itx\rm in mm')
ylabel('\ity\rm in mm')         
title('\itz\rm = 4 ft')         

figure(5)
%plot(yy,20.*log10((Ex_mag1(:,(Nx+1)/2))'./E_n),'LineWidth',2)  
plot(yy,(Ex_mag1(:,(Nx+1)/2))'./E_n,'LineWidth',2)  
xlabel('\itx\rm in mm')
%ylabel('Normalized \itE_x\rm in dB')
ylabel('Normalized |\itE_x\rm|')
title('\itz\rm = 4 ft, \itx\rm = 0')      % z is the x axis

figure(6)
%plot(xx,20.*log10((Ex_mag1(Ny/2,:))./E_n),'LineWidth',2) 
plot(xx,(Ex_mag1(Ny/2,:))./E_n,'LineWidth',2) 
xlabel('\ity\rm in mm')         % actually z axis in this case
%ylabel('Normalized \itE_x\rm in dB')
ylabel('Normalized |\itE_x\rm|')
title('\itz\rm = 4 ft, \ity\rm = 0')      % z is the x axis
